Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_include.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_include.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_include.php	(revision )
@@ -20,6 +20,7 @@
      * caching mode to create nocache code but no cache file
      */
     const CACHING_NOCACHE_CODE = 9999;
+
     /**
      * Attribute definition: Overwrites base class.
      *
@@ -27,6 +28,7 @@
      * @see Smarty_Internal_CompileBase
      */
     public $required_attributes = array('file');
+
     /**
      * Attribute definition: Overwrites base class.
      *
@@ -34,13 +36,15 @@
      * @see Smarty_Internal_CompileBase
      */
     public $shorttag_order = array('file');
+
     /**
      * Attribute definition: Overwrites base class.
      *
      * @var array
      * @see Smarty_Internal_CompileBase
      */
-    public $option_flags = array('nocache', 'inline', 'caching');
+    public $option_flags = array('nocache', 'inline', 'caching', 'bubble_up');
+
     /**
      * Attribute definition: Overwrites base class.
      *
@@ -50,216 +54,313 @@
     public $optional_attributes = array('_any');
 
     /**
+     * Valid scope names
+     *
+     * @var array
+     */
+    public $valid_scopes = array('local'  => true, 'parent' => true, 'root' => true, 'global' => true,
+                                 'smarty' => true, 'tpl_root' => true);
+
+    /**
      * Compiles code for the {include} tag
      *
-     * @param  array  $args      array with attributes from parser
+     * @param  array                                  $args      array with attributes from parser
-     * @param  object $compiler  compiler object
+     * @param  Smarty_Internal_SmartyTemplateCompiler $compiler  compiler object
-     * @param  array  $parameter array with compilation parameter
+     * @param  array                                  $parameter array with compilation parameter
      *
+     * @throws SmartyCompilerException
      * @return string compiled code
      */
-    public function compile($args, $compiler, $parameter)
+    public function compile($args, Smarty_Internal_SmartyTemplateCompiler $compiler, $parameter)
     {
         // check and get attributes
         $_attr = $this->getAttributes($compiler, $args);
-        // save possible attributes
-        $include_file = $_attr['file'];
 
+        $hashResourceName = $fullResourceName = $source_resource = $_attr['file'];
+        $variable_template = false;
+        $cache_tpl = false;
+        // parse resource_name
+        if (preg_match('/^([\'"])(([A-Za-z0-9_\-]{2,})[:])?(([^$()]+)|(.+))\1$/', $source_resource, $match)) {
+            $type = !empty($match[3]) ? $match[3] : $compiler->template->smarty->default_resource_type;
+            $name = !empty($match[5]) ? $match[5] : $match[6];
+            $handler = Smarty_Resource::load($compiler->smarty, $type);
+            if ($handler->recompiled || $handler->uncompiled) {
+                $variable_template = true;
+            }
+            if (!$variable_template) {
+                if ($type != 'string') {
+                    $fullResourceName = "{$type}:{$name}";
+                    $compiled = $compiler->parent_compiler->template->compiled;
+                    if (isset($compiled->includes[$fullResourceName])) {
+                        $compiled->includes[$fullResourceName] ++;
+                        $cache_tpl = true;
+                    } else {
+                        $compiled->includes[$fullResourceName] = 1;
+                    }
+                    $fullResourceName = '"' . $fullResourceName . '"';
+                }
+            }
+            if (empty($match[5])) {
+                $variable_template = true;
+            }
+        } else {
+            $variable_template = true;
+        }
+
         if (isset($_attr['assign'])) {
             // output will be stored in a smarty variable instead of being displayed
             $_assign = $_attr['assign'];
         }
 
-        $_parent_scope = Smarty::SCOPE_LOCAL;
+        // scope setup
+        $_scope = Smarty::SCOPE_LOCAL;
         if (isset($_attr['scope'])) {
             $_attr['scope'] = trim($_attr['scope'], "'\"");
+            if (!isset($this->valid_scopes[$_attr['scope']])) {
+                $compiler->trigger_template_error("illegal value '{$_attr['scope']}' for \"scope\" attribute", null, true);
+            }
+            if ($_attr['scope'] != 'local') {
-            if ($_attr['scope'] == 'parent') {
+                if ($_attr['scope'] == 'parent') {
-                $_parent_scope = Smarty::SCOPE_PARENT;
+                    $_scope = Smarty::SCOPE_PARENT;
-            } elseif ($_attr['scope'] == 'root') {
+                } elseif ($_attr['scope'] == 'root') {
-                $_parent_scope = Smarty::SCOPE_ROOT;
+                    $_scope = Smarty::SCOPE_ROOT;
-            } elseif ($_attr['scope'] == 'global') {
+                } elseif ($_attr['scope'] == 'global') {
-                $_parent_scope = Smarty::SCOPE_GLOBAL;
+                    $_scope = Smarty::SCOPE_GLOBAL;
+                } elseif ($_attr['scope'] == 'smarty') {
+                    $_scope = Smarty::SCOPE_SMARTY;
+                } elseif ($_attr['scope'] == 'tpl_root') {
+                    $_scope = Smarty::SCOPE_TPL_ROOT;
-            }
+                }
+                if ($_attr['bubble_up'] === true) {
+                    $_scope = $_scope + Smarty::SCOPE_BUBBLE_UP;
-        }
+                }
-
-        $_caching = Smarty::CACHING_OFF;
-
-        // flag if included template code should be merged into caller
-        $merge_compiled_includes = ($compiler->smarty->merge_compiled_includes || ($compiler->inheritance && $compiler->smarty->inheritance_merge_compiled_includes) || $_attr['inline'] === true) && !$compiler->template->source->recompiled;
-
-        // set default when in nocache mode
-        //       if ($compiler->template->caching && ($compiler->nocache || $compiler->tag_nocache || $compiler->forceNocache == 2)) {
-        if ($compiler->template->caching && ((!$compiler->inheritance && !$compiler->nocache && !$compiler->tag_nocache) || ($compiler->inheritance && ($compiler->nocache || $compiler->tag_nocache)))) {
-            $_caching = self::CACHING_NOCACHE_CODE;
-        }
+            }
-        /*
-        * if the {include} tag provides individual parameter for caching
-        * it will not be included into the common cache file and treated like
-        * a nocache section
-        */
-        if (isset($_attr['cache_lifetime'])) {
-            $_cache_lifetime = $_attr['cache_lifetime'];
-            $compiler->tag_nocache = true;
-            $_caching = Smarty::CACHING_LIFETIME_CURRENT;
-        } else {
-            $_cache_lifetime = 'null';
         }
-        if (isset($_attr['cache_id'])) {
-            $_cache_id = $_attr['cache_id'];
-            $compiler->tag_nocache = true;
-            $_caching = Smarty::CACHING_LIFETIME_CURRENT;
+
+        // set flag to cache subtemplate object when called within loop or template name is variable.
+        if ($cache_tpl || $variable_template || $compiler->loopNesting > 0) {
+            $_cache_tpl = 'true';
         } else {
-            $_cache_id = '$_smarty_tpl->cache_id';
+            $_cache_tpl = 'false';
         }
-        if (isset($_attr['compile_id'])) {
-            $_compile_id = $_attr['compile_id'];
-        } else {
-            $_compile_id = '$_smarty_tpl->compile_id';
-        }
-        if ($_attr['caching'] === true) {
-            $_caching = Smarty::CACHING_LIFETIME_CURRENT;
-        }
+        // assume caching is off
+        $_caching = Smarty::CACHING_OFF;
+
         if ($_attr['nocache'] === true) {
             $compiler->tag_nocache = true;
-            if ($merge_compiled_includes) {
+        }
+
+        $call_nocache = $compiler->tag_nocache || $compiler->nocache;
+
+        // caching was on and {include} is not in nocache mode
+        if ($compiler->template->caching && !$compiler->nocache && !$compiler->tag_nocache) {
-                $_caching = self::CACHING_NOCACHE_CODE;
+            $_caching = self::CACHING_NOCACHE_CODE;
-            } else {
-                $_caching = Smarty::CACHING_OFF;
-            }
+        }
-        }
 
-        $has_compiled_template = false;
+        // flag if included template code should be merged into caller
+        $merge_compiled_includes = ($compiler->smarty->merge_compiled_includes || $_attr['inline'] === true) &&
+            !$compiler->template->source->handler->recompiled;
+
         if ($merge_compiled_includes && $_attr['inline'] !== true) {
             // variable template name ?
-            if ($compiler->has_variable_string || !((substr_count($include_file, '"') == 2 || substr_count($include_file, "'") == 2))
-                || substr_count($include_file, '(') != 0 || substr_count($include_file, '$_smarty_tpl->') != 0
-            ) {
+            if ($variable_template) {
                 $merge_compiled_includes = false;
-                if ($compiler->inheritance && $compiler->smarty->inheritance_merge_compiled_includes) {
-                    $compiler->trigger_template_error(' variable template file names not allow within {block} tags');
+                if ($compiler->template->caching) {
+                    // must use individual cache file
+                    //$_attr['caching'] = 1;
                 }
             }
             // variable compile_id?
             if (isset($_attr['compile_id'])) {
-                if (!((substr_count($_attr['compile_id'], '"') == 2 || substr_count($_attr['compile_id'], "'") == 2))
-                    || substr_count($_attr['compile_id'], '(') != 0 || substr_count($_attr['compile_id'], '$_smarty_tpl->') != 0
+                if (!((substr_count($_attr['compile_id'], '"') == 2 || substr_count($_attr['compile_id'], "'") == 2 ||
+                        is_numeric($_attr['compile_id']))) || substr_count($_attr['compile_id'], '(') != 0 ||
+                    substr_count($_attr['compile_id'], '$_smarty_tpl->') != 0
                 ) {
                     $merge_compiled_includes = false;
-                    if ($compiler->inheritance && $compiler->smarty->inheritance_merge_compiled_includes) {
-                        $compiler->trigger_template_error(' variable compile_id not allow within {block} tags');
+                    if ($compiler->template->caching) {
+                        // must use individual cache file
+                        //$_attr['caching'] = 1;
                     }
                 }
             }
         }
-        if ($merge_compiled_includes) {
-            if ($compiler->template->caching && ($compiler->tag_nocache || $compiler->nocache) && $_caching != self::CACHING_NOCACHE_CODE) {
-                $merge_compiled_includes = false;
-                if ($compiler->inheritance && $compiler->smarty->inheritance_merge_compiled_includes) {
-                    $compiler->trigger_template_error(' invalid caching mode of subtemplate within {block} tags');
+
+        /*
+        * if the {include} tag provides individual parameter for caching or compile_id
+        * the subtemplate must not be included into the common cache file and is treated like
+        * a call in nocache mode.
+        *
+        */
+        if ($_attr['nocache'] !== true && $_attr['caching']) {
+            $_caching = $_new_caching = (int) $_attr['caching'];
+            $call_nocache = true;
+        } else {
+            $_new_caching = Smarty::CACHING_LIFETIME_CURRENT;
-                }
+        }
+        if (isset($_attr['cache_lifetime'])) {
+            $_cache_lifetime = $_attr['cache_lifetime'];
+            $call_nocache = true;
+            $_caching = $_new_caching;
+        } else {
+            $_cache_lifetime = '$_smarty_tpl->cache_lifetime';
-            }
+        }
+        if (isset($_attr['cache_id'])) {
+            $_cache_id = $_attr['cache_id'];
+            $call_nocache = true;
+            $_caching = $_new_caching;
+        } else {
+            $_cache_id = '$_smarty_tpl->cache_id';
         }
-        if ($merge_compiled_includes) {
-            // we must observe different compile_id
-            $uid = sha1($_compile_id);
-            $tpl_name = null;
-            $nocache = false;
-            /** @var Smarty_Internal_Template $_smarty_tpl
-             * used in evaluated code
-             */
-            $_smarty_tpl = $compiler->template;
-            eval("\$tpl_name = $include_file;");
-            if (!isset($compiler->smarty->merged_templates_func[$tpl_name][$uid])) {
-                $tpl = new $compiler->smarty->template_class ($tpl_name, $compiler->smarty, $compiler->template, $compiler->template->cache_id, $compiler->template->compile_id);
-                // save unique function name
-                $compiler->smarty->merged_templates_func[$tpl_name][$uid]['func'] = $tpl->properties['unifunc'] = 'content_' . str_replace(array('.', ','), '_', uniqid('', true));
-                // use current nocache hash for inlined code
-                $compiler->smarty->merged_templates_func[$tpl_name][$uid]['nocache_hash'] = $tpl->properties['nocache_hash'] = $compiler->template->properties['nocache_hash'];
-                if ($compiler->template->caching && $_caching == self::CACHING_NOCACHE_CODE) {
-                    // all code must be nocache
-                    $nocache = true;
+        if (isset($_attr['compile_id'])) {
+            $_compile_id = $_attr['compile_id'];
+        } else {
+            $_compile_id = '$_smarty_tpl->compile_id';
-                }
+        }
-                if ($compiler->inheritance) {
-                    $tpl->compiler->inheritance = true;
-                }
-                // make sure whole chain gets compiled
-                $tpl->mustCompile = true;
-                if (!($tpl->source->uncompiled) && $tpl->source->exists) {
 
-                    // get compiled code
-                    $compiled_code = $tpl->compiler->compileTemplate($tpl, $nocache);
-                    // release compiler object to free memory
-                    unset($tpl->compiler);
-                    // merge compiled code for {function} tags
-                    $compiler->template->properties['function'] = array_merge($compiler->template->properties['function'], $tpl->properties['function']);
-                    // merge filedependency
-                    $tpl->properties['file_dependency'][$tpl->source->uid] = array($tpl->source->filepath, $tpl->source->timestamp, $tpl->source->type);
-                    $compiler->template->properties['file_dependency'] = array_merge($compiler->template->properties['file_dependency'], $tpl->properties['file_dependency']);
-                    // remove header code
-                    $compiled_code = preg_replace("/(<\?php \/\*%%SmartyHeaderCode:{$tpl->properties['nocache_hash']}%%\*\/(.+?)\/\*\/%%SmartyHeaderCode%%\*\/\?>\n)/s", '', $compiled_code);
-                    if ($tpl->has_nocache_code) {
-                        // replace nocache_hash
-                        $compiled_code = str_replace("{$tpl->properties['nocache_hash']}", $compiler->template->properties['nocache_hash'], $compiled_code);
-                        $compiler->template->has_nocache_code = true;
+        // if subtemplate will be called in nocache mode do not merge
+        if ($compiler->template->caching && $call_nocache) {
+            $merge_compiled_includes = false;
-                    }
+        }
-                    $compiler->merged_templates[$tpl->properties['unifunc']] = $compiled_code;
-                    $has_compiled_template = true;
-                    unset ($tpl);
-                }
+
+        $has_compiled_template = false;
+        if ($merge_compiled_includes) {
+            $c_id = isset($_attr['compile_id']) ? $_attr['compile_id'] : $compiler->template->compile_id;
+            // we must observe different compile_id and caching
+            $t_hash = sha1($c_id . ($_caching ? '--caching' : '--nocaching'));
+            if (!isset($compiler->parent_compiler->mergedSubTemplatesData[$hashResourceName][$t_hash])) {
+                $has_compiled_template =
+                    $this->compileInlineTemplate($compiler, $fullResourceName, $_caching, $hashResourceName, $t_hash,
+                                                 $c_id);
             } else {
                 $has_compiled_template = true;
             }
         }
         // delete {include} standard attributes
-        unset($_attr['file'], $_attr['assign'], $_attr['cache_id'], $_attr['compile_id'], $_attr['cache_lifetime'], $_attr['nocache'], $_attr['caching'], $_attr['scope'], $_attr['inline']);
+        unset($_attr['file'], $_attr['assign'], $_attr['cache_id'], $_attr['compile_id'], $_attr['cache_lifetime'], $_attr['nocache'], $_attr['caching'], $_attr['scope'], $_attr['inline'], $_attr['bubble_up']);
         // remaining attributes must be assigned as smarty variable
+        $_vars_nc = '';
         if (!empty($_attr)) {
-            if ($_parent_scope == Smarty::SCOPE_LOCAL) {
+            if ($_scope == Smarty::SCOPE_LOCAL) {
+                $_pairs = array();
                 // create variables
-                $nccode = '';
                 foreach ($_attr as $key => $value) {
                     $_pairs[] = "'$key'=>$value";
-                    $nccode .= "\$_smarty_tpl->tpl_vars['$key'] =  new Smarty_variable($value);\n";
+                    $_vars_nc .= "\$_smarty_tpl->tpl_vars['$key'] =  new Smarty_Variable($value);\n";
                 }
                 $_vars = 'array(' . join(',', $_pairs) . ')';
             } else {
-                $compiler->trigger_template_error('variable passing not allowed in parent/global scope', $compiler->lex->taglineno);
+                $compiler->trigger_template_error('variable passing not allowed in parent/global scope', null, true);
             }
         } else {
             $_vars = 'array()';
         }
-        if ($has_compiled_template) {
-            // never call inline templates in nocache mode
-            $compiler->suppressNocacheProcessing = true;
-            $_hash = $compiler->smarty->merged_templates_func[$tpl_name][$uid]['nocache_hash'];
-            $_output = "<?php /*  Call merged included template \"" . $tpl_name . "\" */\n";
-            $_output .= "\$_tpl_stack[] = \$_smarty_tpl;\n";
-            if (!empty($nccode) && $_caching == 9999 && $_smarty_tpl->caching) {
-                $compiler->suppressNocacheProcessing = false;
-                $_output .=  substr($compiler->processNocacheCode('<?php ' .$nccode . "?>\n", true), 6, -3);
-                $compiler->suppressNocacheProcessing = true;
+        $update_compile_id = $compiler->template->caching && !$compiler->tag_nocache && !$compiler->nocache &&
+            $_compile_id != '$_smarty_tpl->compile_id';
+        if ($has_compiled_template && !$call_nocache) {
+            $_output = "<?php\n";
+            if ($update_compile_id) {
+                $_output .= $compiler->makeNocacheCode("\$_compile_id_save[] = \$_smarty_tpl->compile_id;\n\$_smarty_tpl->compile_id = {$_compile_id};\n");
             }
-            $_output .= " \$_smarty_tpl = \$_smarty_tpl->setupInlineSubTemplate($include_file, $_cache_id, $_compile_id, $_caching, $_cache_lifetime, $_vars, $_parent_scope, '$_hash');\n";
+            if (!empty($_vars_nc) && $_caching == 9999 && $compiler->template->caching) {
+                //$compiler->suppressNocacheProcessing = false;
+                $_output .= substr($compiler->processNocacheCode('<?php ' . $_vars_nc . "?>\n", true), 6, - 3);
+                //$compiler->suppressNocacheProcessing = true;
+            }
             if (isset($_assign)) {
-                $_output .= 'ob_start(); ';
+                $_output .= "ob_start();\n";
             }
-            $_output .= $compiler->smarty->merged_templates_func[$tpl_name][$uid]['func'] . "(\$_smarty_tpl);\n";
-            $_output .= "\$_smarty_tpl = array_pop(\$_tpl_stack); ";
+            $_output .= "\$_smarty_tpl->smarty->ext->_subtemplate->render(\$_smarty_tpl, {$fullResourceName}, {$_cache_id}, {$_compile_id}, {$_caching}, {$_cache_lifetime}, {$_vars}, {$_scope}, {$_cache_tpl}, '{$compiler->parent_compiler->mergedSubTemplatesData[$hashResourceName][$t_hash]['uid']}', '{$compiler->parent_compiler->mergedSubTemplatesData[$hashResourceName][$t_hash]['func']}');\n";
             if (isset($_assign)) {
-                $_output .= " \$_smarty_tpl->tpl_vars[$_assign] = new Smarty_variable(ob_get_clean());";
+                $_output .= "\$_smarty_tpl->assign({$_assign}, ob_get_clean());\n";
             }
-            $_output .= "\n/*  End of included template \"" . $tpl_name . "\" */?>";
+            if ($update_compile_id) {
+                $_output .= $compiler->makeNocacheCode("\$_smarty_tpl->compile_id = array_pop(\$_compile_id_save);\n");
+            }
+            $_output .= "?>\n";
 
             return $_output;
         }
 
+        if ($call_nocache) {
+            $compiler->tag_nocache = true;
+        }
+        $_output = "<?php ";
+        if ($update_compile_id) {
+            $_output .= "\$_compile_id_save[] = \$_smarty_tpl->compile_id;\n\$_smarty_tpl->compile_id = {$_compile_id};\n";
+        }
         // was there an assign attribute
         if (isset($_assign)) {
-            $_output = "<?php \$_smarty_tpl->tpl_vars[$_assign] = new Smarty_variable(\$_smarty_tpl->getSubTemplate ($include_file, $_cache_id, $_compile_id, $_caching, $_cache_lifetime, $_vars, $_parent_scope));?>\n";;
-        } else {
-            $_output = "<?php echo \$_smarty_tpl->getSubTemplate ($include_file, $_cache_id, $_compile_id, $_caching, $_cache_lifetime, $_vars, $_parent_scope);?>\n";
+            $_output .= "ob_start();\n";
         }
-
+        $_output .= "\$_smarty_tpl->smarty->ext->_subtemplate->render(\$_smarty_tpl, {$fullResourceName}, $_cache_id, $_compile_id, $_caching, $_cache_lifetime, $_vars, $_scope, {$_cache_tpl});\n";
+        if (isset($_assign)) {
+            $_output .= "\$_smarty_tpl->assign({$_assign}, ob_get_clean());\n";
+        }
+        if ($update_compile_id) {
+            $_output .= "\$_smarty_tpl->compile_id = array_pop(\$_compile_id_save);\n";
+        }
+        $_output .= "?>\n";
         return $_output;
+    }
+
+    /**
+     * Compile inline sub template
+     *
+     * @param \Smarty_Internal_SmartyTemplateCompiler $compiler
+     * @param                                         $fullResourceName
+     * @param                                         $_caching
+     * @param                                         $hashResourceName
+     * @param                                         $t_hash
+     * @param                                         $c_id
+     *
+     * @return bool
+     */
+    public function compileInlineTemplate(Smarty_Internal_SmartyTemplateCompiler $compiler, $fullResourceName,
+                                          $_caching, $hashResourceName, $t_hash, $c_id)
+    {
+        $compiler->smarty->allow_ambiguous_resources = true;
+        /* @var Smarty_Internal_Template $tpl */
+        $tpl =
+            new $compiler->smarty->template_class (trim($fullResourceName, '"\''), $compiler->smarty, $compiler->template,
+                                                   $compiler->template->cache_id, $c_id, $_caching);
+        if (!($tpl->source->handler->uncompiled) && $tpl->source->exists) {
+            $compiler->parent_compiler->mergedSubTemplatesData[$hashResourceName][$t_hash]['uid'] = $tpl->source->uid;
+            if (isset($compiler->template->_inheritance)) {
+                $tpl->_inheritance = clone $compiler->template->_inheritance;
+            }
+            $tpl->compiled = new Smarty_Template_Compiled();
+            $tpl->compiled->nocache_hash = $compiler->parent_compiler->template->compiled->nocache_hash;
+            $tpl->loadCompiler();
+            // save unique function name
+            $compiler->parent_compiler->mergedSubTemplatesData[$hashResourceName][$t_hash]['func'] =
+            $tpl->compiled->unifunc = 'content_' . str_replace(array('.', ','), '_', uniqid('', true));
+            // make sure whole chain gets compiled
+            $tpl->mustCompile = true;
+            $compiler->parent_compiler->mergedSubTemplatesData[$hashResourceName][$t_hash]['nocache_hash'] =
+                $tpl->compiled->nocache_hash;
+            // get compiled code
+            $compiled_code = "<?php\n\n";
+            $compiled_code .= "/* Start inline template \"{$tpl->source->type}:{$tpl->source->name}\" =============================*/\n";
+            $compiled_code .= "function {$tpl->compiled->unifunc} (\$_smarty_tpl) {\n";
+            $compiled_code .= "?>\n" . $tpl->compiler->compileTemplateSource($tpl, null, $compiler->parent_compiler);
+            $compiled_code .= "<?php\n";
+            $compiled_code .= "}\n?>\n";
+            $compiled_code .= $tpl->compiler->postFilter($tpl->compiler->blockOrFunctionCode);
+            $compiled_code .= "<?php\n\n";
+            $compiled_code .= "/* End inline template \"{$tpl->source->type}:{$tpl->source->name}\" =============================*/\n";
+            $compiled_code .= "?>";
+            unset($tpl->compiler);
+            if ($tpl->compiled->has_nocache_code) {
+                // replace nocache_hash
+                $compiled_code =
+                    str_replace("{$tpl->compiled->nocache_hash}", $compiler->template->compiled->nocache_hash,
+                                $compiled_code);
+                $compiler->template->compiled->has_nocache_code = true;
+            }
+            $compiler->parent_compiler->mergedSubTemplatesCode[$tpl->compiled->unifunc] = $compiled_code;
+            return true;
+        } else {
+            return false;
+        }
     }
 }
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerdefaultpluginhandler.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerdefaultpluginhandler.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerdefaultpluginhandler.php	(revision )
@@ -0,0 +1,43 @@
+<?php
+
+/**
+ * Smarty Method RegisterDefaultPluginHandler
+ *
+ * Smarty::registerDefaultPluginHandler() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_RegisterDefaultPluginHandler
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * Registers a default plugin handler
+     *
+     * @api  Smarty::registerDefaultPluginHandler()
+     * @link http://www.smarty.net/docs/en/api.register.default.plugin.handler.tpl
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  callable                                                       $callback class/method name
+     *
+     * @return \Smarty|\Smarty_Internal_Template
+     * @throws SmartyException              if $callback is not callable
+     */
+    public function registerDefaultPluginHandler(Smarty_Internal_TemplateBase $obj, $callback)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        if (is_callable($callback)) {
+            $smarty->default_plugin_handler_func = $callback;
+        } else {
+            throw new SmartyException("Default plugin handler '$callback' not callable");
+        }
+        return $obj;
+    }
+}
\ No newline at end of file
